<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 1.0.0 $Id: listofarticles2.php,v 1.4 2011-06-14 19:23:36 harry Exp $
 * @author Harry Klein <harry.klein@joomla-hklein.de>
 * @package Joomla
 * @subpackage H2N List of Articles 2, fork of List of Articles, see http://www.designcompasscorp.com 
 * @copyright (C) 2010-2011 DesignCompassCorp. All rights reserved.
 * @copyright (C) 2010 Harry Klein - www.joomla-hklein.de. All rights reserved.
 * @license GNU/GPL
 *
 * H2N List of Articles 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N List of Articles 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.event.plugin');

class plgContentListOfArticles2 extends JPlugin {
	//Which mode to operate in - ArticleList or MenuList
	const ARTICLELIST = 0  ;
	const MENULIST = 1  ;

	//Search Text Options
	const BEGIN = 0 ;
	const END = 1 ;

	//Return options
	const PLUGIN = 0  ;
	const DB  = 1 ;
	const SEARCH =  2 ;
	const COLS = 3  ;
	const ORDER = 4  ;

	//Parameter positions
	const ID = 0;
	const TITLE = 1;
	const WIDTH = 2 ;
	const START = 3 ;
	const LIMIT = 4 ;

	//Seperators
	const PLUGSEP = '='  ;
	const OPTSEP = ','  ;
	const PLUGSTART = '{'  ;

	const PLUGEND = '}'  ;

	private $articlecssclass;
	private $menucssclass;
	private $css;

	public function plgContentListOfArticles2(&$subject, $config = null){
		parent::__construct($subject, $config);
		$this->loadLanguage( 'plg_content_mosimage', JPATH_ADMINISTRATOR);
		$document=& JFactory::getDocument();
		$baseUrl = JURI::base().'plugins/content/listofarticles2';
		$document->addStyleSheet($baseUrl.'/css/listofarticles2.css');
		$pluginParams	= new JParameter( $config['params'] );
		$css = $pluginParams->get('css');
		$document->addStyleDeclaration($css);
	}

	public function onPrepareContent(&$row, &$params, $page=0 ) {
		$plugin			=& JPluginHelper::getPlugin('content', 'listofarticles2');
		$pluginParams	= new JParameter( $plugin->params );
		$this->articlecssclass=$pluginParams->get( 'articlecssclass' );
		$this->menucssclass=$pluginParams->get( 'menucssclass' );
		return ( is_object ($row)?$this->plgListOfArticles ( $row->text, $params ):$this->plgListOfArticles ( $row, $params ) ) ;
	}

	private function retVals ( $key, $mode ){
		$version= new JVersion();
		switch ( $mode ) {
			case self::MENULIST	:
				switch ( $key ) {
					case	self::PLUGIN: return 'menuitemsoftype';
					case	self::DB	: return 'menu';
					case	self::SEARCH: return 'menutype';
					case	self::COLS	: return ($version->RELEASE == '1.6') ? 'id,title,link,menutype': 'id,name,link,type' ;
					case	self::ORDER	: return 'ordering';
					break;
				}
			case self::ARTICLELIST	:
				switch ( $key ) {
					case	self::PLUGIN : return 'articlesofcategory';
					case	self::DB     : return 'content';
					case	self::SEARCH : return 'catid' ;
					case	self::COLS   : return 'id,title,introtext,created';
					case	self::ORDER  : return 'ordering,title';
				}
				break;
			default:
				return '';
		}
		return ( '' ) ;
	}


	private function plgListOfArticles(&$text, &$params)
	{
		$this->CreateList ( $text, self::ARTICLELIST ) ;
		$this->CreateList ( $text, self::MENULIST) ;
		return true;
	}

	private function CreateList ( &$text, $Mode )
	{
		$options = array () ;
		$fList=$this->LOAgetListToReplace($this->retVals (self::PLUGIN, $Mode),$options,$text,self::PLUGSTART.self::PLUGEND);
		$text = $this->replaceText ( $fList, $options, $text, $Mode, 0 ) ;
	}

	private function replaceWith ( $options, $mode)
	{
		$opts = $this->Options ( explode ( self::OPTSEP,$options, 5 )) ;
		$rows = $this->getRows ( $mode, $opts);

		switch ( $mode )
		{
			case self::ARTICLELIST :
				return $this->LOAmakeArticleList ($rows, $opts) ;
			case self::MENULIST :
				return $this->LOAmakeMenuList ($rows,$opts);
		}
	}


	private function Options ( $opts)
	{
		$ret = array () ;
		$ret[self::ID] = ( $opts[0]==''?'%':$opts[0] );

		if(isset($opts[self::TITLE])) {
			$ret[self::TITLE] = $opts[self::TITLE] ;
		}

		if(isset($opts[self::WIDTH])){
			$ret[self::WIDTH] = (int)$opts[self::WIDTH] ;
		}

		$ret[self::START] = intval($opts[self::START]) ;
		if ($ret[self::START] < 0){
			$ret[self::START] = 0;
		}

		$ret[self::LIMIT] = intval($opts[self::LIMIT]);
		if ($ret[self::LIMIT] < 0){
			$ret[self::LIMIT] = 0;
		}
		return ( $ret ) ;
	}

	private function isTrue ( $check, $val1, $val2 ) {
		return ( $check ? $val1 : $val2 ) ;
	}
	private function retSearch ( $Search ) {
		return ( '="'.( $Search == '' ? '%' : $Search ).'"' ) ;
	}
	private function replaceText ( $fList, $options, $text, $Mode, $count) {
		return ( $count==count( $fList ) ? $text : $this->replaceText ($fList, $options, str_replace ( $fList[$count], $this->replaceWith ( $options[$count], $Mode ), $text ), $Mode, $count+1 ) ) ;
	}

	private function LOAmakeLink ( $link, $title, $sep=false ) {
		return ( $sep ? '<li class="separator">'.$title.'</li>':'<li><a href="'.$link.'">'.$title.'</a></li>' ) ;
	}

	private function LOAmakeArticleLink (&$row)
	{
		$url = ContentHelperRoute::getArticleRoute($row->id);
        if ($url == null){
        	$url = 'index.php?option=com_content&view=article&id='.$row->id.'&Itemid='.JRequest::getInt ('Itemid', 0);
		}
        return $this->LOAmakeLink(JRoute::_($url), $row->title);
	}


	private function LOAmakeArticleLinks ( $Itemid, $rows, $count) {
		return ( $count==count ($rows) ? '' : $this->LOAmakeArticleLink ($rows[$count] ).$this->LOAmakeArticleLinks ( $Itemid, $rows, $count+1 ) ) ;
	}

	private function LOAmakeArticleList(&$rows, &$opts) {
		return (
		$this->getHeader($opts)
		.$this->LOAmakeArticleLinks (JRequest::getInt ('Itemid'), $rows, 0 )
		.$this->getFooter()
		);
	}

	private function LOAmakeMenuListLink ( $row )
	{
		if($GLOBALS['version']->RELEASE == '1.6') {
			return ( $this->LOAmakeLink ( ( $row->link.'&Itemid='.$row->id ), $row->title, ( $row->menutype == 'separator' ) ) ) ;
		}
		else {
			return ( $this->LOAmakeLink ( ( $row->link.'&Itemid='.$row->id ), $row->name, ( $row->type == 'separator' ) ) ) ;
		}
	}

	private function LOAmakeMenuListLinks ( $Itemid, $rows, $count ) {
		return ( $count==count($rows) ? '' : $this->LOAmakeMenuListLink ( $rows[$count] ).$this->LOAmakeMenuListLinks ( $Itemid, $rows, $count+1 ) ) ;
	}

	private function getCss($width){
		if ($width == 0){ // use default width, see listofarticles-0
			return '';
		}
		if ($width == -1){ // one column only
			return '<style type="text/css">ul.listofarticles2-one li a {width: '.($width-3).'em;} \
			ul.listofarticles2-one li {width: '.$width.'em;}</style>';
		}
		return '<style type="text/css">ul.listofarticles2-'.$width.' li a {width: '.($width-3).'em;} \
		ul.listofarticles2-'.$width.' li {width: '.$width.'em;float: left;}</style>';
	}

	private function getCssClass($width){
		if ($width == -1){
			return ' listofarticles2-one';
		}
		return ' listofarticles2-'.intVal($width);
	}

	private function getHeader(&$opts){
		$width=$opts[self::WIDTH];
		return ( $this->getCss($width).'<!--ContentList-Article List-->'
		.($this->articlecssclass ? '<div class="'.$this->articlecssclass.'">' : '')
		.('<fieldset class="listofarticles2"><legend>'.$opts[self::TITLE]."</legend>")
		.'<ul class="listofarticles2'.$this->getCssClass($width).'">');
	}

	private function getFooter(){
		return '</ul></fieldset><br class="listofarticles2"/>'
		.($this->articlecssclass ? '</div>' : '');
	}


	private function LOAmakeMenuList(&$rows, &$opts) {
		return (
		$this->getHeader($opts)
		.$this->LOAmakeMenuListLinks ( JRequest::getInt('Itemid',0), $rows, 0 )
		.$this->getFooter()
		);
	}

	//Builds SQL
	private function buildSelect ( $Mode ) {
		return ( 'SELECT '.$this->retVals( self::COLS, $Mode ) ) ;
	}
	private function buildFrom ( $Mode ) {
		return ( ' FROM #__'.$this->retVals ( self::DB, $Mode ) ) ;
	}
	private function buildWhere ( $Itemid, &$opts, $Mode ) {
		return ( ' WHERE '.$this->buildSearch ($opts[self::ID], $Mode ) ) ;
	}
	private function buildOrder ( $Mode ) {
		return ( ' ORDER BY '.$this->retVals ( self::ORDER, $Mode ) ) ;
	}

	private function buildQuery ($Mode , $Itemid=0, $opts) {
		return $this->buildSelect($Mode).$this->buildFrom($Mode).$this->buildWhere($Itemid,$opts,$Mode).$this->buildOrder($Mode);
	}

	private function buildSearch ( $Search, $Mode ) {
		if($Mode == self::MENULIST) {
			return (  'published=1 AND '.$this->retVals ( self::SEARCH,$Mode ).$this->retSearch ($Search ) ) ;
		}
		else {
			return ( 'state=1 AND ' . $this->retVals ( self::SEARCH,$Mode ).$this->retSearch ($Search ) ) ;
		}
	}

	private function getRows($Mode, $opts)
	{
		$Itemid=JRequest::getInt ('Itemid',0);
		$langObj=JFactory::getLanguage();
		$nowLang=$langObj->getTag();
		$db = & JFactory::getDBO();
		$query=$this->buildQuery ($Mode, $Itemid, $opts);
		$db->setQuery ( $query ,$opts[self::START], $opts[self::LIMIT] ) ;
		if (!$db->query())
		echo ( $db->stderr());
		return ( $db->loadObjectList() );
	}


	//Finding plugin locations in text.
	private function Find ( $Text, $Match, $Offset, $Mode ) {
		return ( $Mode == self::BEGIN ? $this->FindPlugin ( $Text, $this->LeftStr ( $Match, strlen ( $Match ) - 1 ), $Offset ) : $this->FindPlugin ( $Text, $Match[strlen($Match)-1], $Offset ) ) ;
	}
	private function FindPlugin ( $Haystack, $Needle, $Count ) {
		return ( ( $Needle == substr ( $Haystack, $Count, strlen ( $Needle ) ) ) ? $Count : ( ( $Count < strlen ( $Haystack ) ) ? $this->FindPlugin ( $Haystack, $Needle, $Count+1 ) : -1 ) ) ;
	}
	private function FindStartPlugin ( $Text, $Match, &$Offset ) {
		return ( $this->Find ( $Text, $Match, $Offset, self::BEGIN ) ) ;
	}
	private function FindLenPlugin ( $Text, $Match, $Offset ) {
		return $this->Length ( $Text, $Match, $Offset, self::END ) ;
	}
	private function Length ( $Text, $Match, $Offset, $Mode ) {
		$ret = $this->Find ( $Text, $Match, $Offset, $Mode ) ;
		return ( $ret !== -1 ? $ret - $Offset + 2 : $ret ) ;
	}
	private function SplitOptions ( $Text, $PreTxt ) {
		return ( $this->MidStr ( $Text, strlen ( $PreTxt ) - 1, strlen ( $Text ) -1 ) ) ;
	}
	private function GetPluginText ( $Text, $Match, &$Offset )
	{
		$start = $this->FindStartPlugin ( $Text, $Match, $Offset ) ;
		$len = $this->FindLenPlugin ( $Text, $Match, $start+1 ) ;
		$Offset = $start + $len + 1 ;
		return ( ( ( $start == -1 ) || ( $len == -1 ) ) ? -1 :  substr ( $Text, $start, $len ) ) ;
	}

	//Various string functions equivalent to C++ Left, Right and Mid string functions
	private function LeftStr ( $str, $end ) {
		return ( $this->MidStr ( $str, 0, $end ) ) ;
	}
	private function RightStr ( $str, $start ) {
		return ( $this->MidStr ( $str, $start, strlen ( $str ) ) ) ;
	}
	private function MidStr ( $str, $start, $end ) {
		return ( substr ( $str, $start, $end-$start ) ) ;
	}

	private function GetAllPlugins ( $Text, $Match, &$Offset, &$fList, &$Options )
	{
		$plugin = $this->GetPluginText ( $Text, $Match, $Offset ) ;
		if ( $plugin == -1 ) return ( '' ) ;
		$fList[] = $plugin ;
		$Options[] = $this->SplitOptions ( $plugin, $Match ) ;
		$this->GetAllPlugins ( $Text, $Match, $Offset, $fList, $Options ) ;
	}

	private function LOAgetListToReplace($par,&$options,&$text,$qtype)
	{
		$fList=array();
		$l=strlen($par)+2;
		$match = $qtype[0].$par.self::PLUGSEP.$qtype[1] ;
		$offset=0;
		$this->GetAllPlugins ( $text, $match, $offset, $fList, $options ) ;
		//for these with no parameters
		if ( $this->FindPlugin ( $text, $match, 0 ) == -1 )
		{
			$options[]='';
			$fList[]=$qtype[0].$par.$qtype[1];
		}
		return $fList;
	}

}